/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* Ce logiciel est du domaine public. Vous avez la permission   *
* d'utiliser, de copier et de modifier ce logiciel.            *
****************************************************************
* Ne me contactez pas SVP pour des informations, bugs,         *
* commentaires, problemes, contributions, offres d'emploi.     *
* Si vous aimez ce logiciel, envoyez une carte postale a       *
* l'adresse suivante :                                         *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA (Moldavie)                                           *
****************************************************************
* L'auteur n'est pas responsable pour les dommages occasionnes *
* par l'utilisation de ce logiciel ou de ses derives.          *
\**************************************************************/

import java.applet.Applet;
import java.awt.*;
import java.util.*;
import java.io.*;

public class VasJavaVersHTML extends Applet {
  //c'est pour l'applet
  Label lEtat;
  TextArea taContenu;
  Button bProceder;
  //pour passer d'une case a l'autre avec tabulation
  Component[] compo;

  //on travaille en mode ligne de command ou dans une applet
  boolean estApplet=true;

  //quel est le separteur de ligne pour le syteme courant (\r\n ou juste \n)
  String sepLigne=new String(System.getProperty("line.separator"));

  //le tableau avec les "classes Java connues" (1.02)
  String[] classes={"VasOnglets", "VasTabs", "AbstractMethodError", "Applet", "AppletContext", "AppletStub", "ArithmeticException", "ArrayIndexOutOfBoundsException", "ArrayStoreException", "AudioClip", "AWTError", "AWTException", "BitSet", "Boolean", "BorderLayout", "BufferedInputStream", "BufferedOutputStream", "Button", "ByteArrayInputStream", "ByteArrayOutputStream", "Canvas", "CardLayout", "Character", "Checkbox", "CheckboxGroup", "CheckboxMenuItem", "Choice", "Class", "ClassCastException", "ClassCircularityError", "ClassFormatError", "ClassLoader", "ClassNotFoundException", "Cloneable", "CloneNotSupportedException", "Color", "ColorModel", "Compiler", "Component", "Container", "ContentHandler", "ContentHandlerFactory", "CropImageFilter", "DatagramPacket", "DatagramSocket", "DataInput", "DataInputStream", "DataOutput", "DataOutputStream", "Date", "Dialog", "Dictionary", "Dimension", "DirectColorModel", "Double", "EmptyStackException", "Enumeration", "EOFException", "Error", "Event", "Exception", "File", "FileDescriptor", "FileDialog", "FileInputStream", "FilenameFilter", "FileNotFoundException", "FileOutputStream", "FilteredImageSource", "FilterInputStream", "FilterOutputStream", "Float", "FlowLayout", "Font", "FontMetrics", "Frame", "Graphics", "GridBagConstraints", "GridBagLayout", "GridLayout", "Hashtable", "IllegalAccessError", "IllegalAccessException", "IllegalArgumentException", "IllegalMonitorStateException", "IllegalThreadStateException", "Image", "ImageConsumer", "ImageFilter", "ImageObserver", "ImageProducer", "IncompatibleClassChangeError", "IndexColorModel", "IndexOutOfBoundsException", "InetAddress", "InputStream", "Insets", "InstantiationError", "InstantiationException", "Integer", "InternalError", "InterruptedException", "InterruptedIOException", "IOException", "Label", "LayoutManager", "LineNumberInputStream", "LinkageError", "List", "Long", "MalformedURLException", "Math", "MediaTracker", "MemoryImageSource", "Menu", "MenuBar", "MenuComponent", "MenuContainer", "MenuItem", "NegativeArraySizeException", "NoClassDefFoundError", "NoSuchElementException", "NoSuchFieldError", "NoSuchMethodError", "NoSuchMethodException", "NullPointerException", "Number", "NumberFormatException", "Object", "Observable", "Observer", "OutOfMemoryError", "OutputStream", "Panel", "PipedInputStream", "PipedOutputStream", "PixelGrabber", "PlainSocketImpl", "Point", "Polygon", "PrintStream", "Process", "Properties", "ProtocolException", "PushbackInputStream", "Random", "RandomAccessFile", "Rectangle", "RGBImageFilter", "Runnable", "Runtime", "RuntimeException", "Scrollbar", "SecurityException", "SecurityManager", "SequenceInputStream", "ServerSocket", "Socket", "SocketException", "SocketImpl", "SocketImplFactory", "SocketInputStream", "SocketOutputStream", "Stack", "StackOverflowError", "StreamTokenizer", "String", "StringBuffer", "StringBufferInputStream", "StringIndexOutOfBoundsException", "StringTokenizer", "System", "TextArea", "TextComponent", "TextField", "Thread", "ThreadDeath", "ThreadGroup", "Throwable", "Toolkit", "UnknownError", "UnknownHostException", "UnknownServiceException", "UnsatisfiedLinkError", "URL", "URLConnection", "URLEncoder", "URLStreamHandler", "URLStreamHandlerFactory", "UTFDataFormatException", "Vector", "VerifyError", "VirtualMachineError", "Window"};

  //tableau de tous les mots reserves
  String[] motsCle={"abstract", "boolean", "break", "byte", "byvalue", "case", "catch", "char", "class", "const", "continue", "default", "do", "double", "else", "extends", "false", "final", "finally", "float", "for", "goto", "if", "implements", "import", "instanceof", "int", "interface", "long", "native", "new", "null", "package", "private", "protected", "public", "return", "short", "static", "super", "switch", "synchronized", "this", "threadsafe", "throw", "transient", "true", "try", "void", "while"};

  //tableau avec tous les types de donnees
  String[] types={"boolean", "byte", "char", "double", "float", "int", "long", "short"};

  //"dictionnaire" pour changer les mots
  Hashtable variablesPrivees=new Hashtable();

  //"dictionnaire" des variables publiques, que l'on ne change pas
  Hashtable variablesPubliques=new Hashtable();

  Vector tousLesTokens=new Vector();
  Vector typeDuToken=new Vector();
  int estMot=0;
  int estEspace=1;
  int estChaine=2;
  int estCommentaire1=3;
  int estCommentaire2=4;
  int estCaractere=5;

  int estMotCle=6;
  int estMotClePublic=7;
  int estMotCleThis=8;

  int estMotCleTypeDeDonnee=9;
  int estClasseJavaConnue=10;

  int estVariablePrivee=11;
  int estVariablePublique=12;

  int estEntier=13;
  int estHexadecimal=14;
  int estLong=15;
  int estOctal=16;
  int estDouble=17;
  int estFloat=18;

  int estInconnu=19;

  //tableau de chaines pour differencier les differents types de tokens
  String[] strFont={
    //int estMot=0;
    "",
    //int estEspace=1;
    "",
    //int estChaine=2;
    //chaine pour differencier une chaine de caracteres
    "<FONT COLOR=\"red\">",
    //int estCommentaire1=3;
    //chaine pour differencier un commentaire de type /**/
    "<FONT COLOR=\"green\">",
    //int estCommentaire2=4;
    //chaine pour differencier un commentaire//
    "<FONT COLOR=\"green\">",
    //int estCaractere=5;
    //chaine pour differencier un caractere
    "<FONT COLOR=\"#00FFFF\">",
    //int estMotCle=6;
    //chaine pour differencier un mot-cle
    "<FONT COLOR=\"blue\">",
    //int estMotClePublic=7;
    "<FONT COLOR=\"blue\">",
    //int estMotCleThis=8;
    "<FONT COLOR=\"blue\">",
    //int estMotCleTypeDeDonnee=9;
    "<FONT COLOR=\"blue\">",
    //chaine pour differencier une "classe Java connue"
    //int estClasseJavaConnue=10;
    "<FONT COLOR=\"yellow\">",
    //int estVariablePrivee=11;
    "",
    //int estVariablePublique=12;
    "",
    //chaine pour differencier les nombres
    //int estEntier=13;
    "<B>",
    //int estHexadecimal=14;
    "<FONT COLOR=\"#0000BF\">",
    //int estLong=15;
    "<FONT COLOR=\"#CAFEBA\">",
    //int estOctal=16;
    "<FONT COLOR=\"#BB00BB\">",
    //int estDouble=17;
    "<FONT COLOR=\"white\">",
    //int estFloat=18;
    "<FONT COLOR=\"white\">",
    //int estInconnu=19;
    //chaine pour differencier "des mots inconnus"
    ""
  };

  //tableau de chaines pour finir de differencier les differents types de tokens
  String[] strEndFont={
    //int estMot=0;
    "",
    //int estEspace=1;
    "",
    //int estChaine=2;
    //chaine pour terminer la differenciation d'une chaine de caracteres
    "</FONT>",
    //int estCommentaire1=3;
    //chaine pour terminer la differenciation d'un commentaire/**/
    "</FONT>",
    //int estCommentaire2=4;
    //chaine pour terminer la differenciation d'un commentaire//
    "</FONT>",
    //int estCaractere=5;
    //chaine pour terminer la differenciation d'un caractere
    "</FONT>",
    //int estMotCle=6;
    //chaine pour terminer la differenciation d'un mot cle
    "</FONT>",
    //int estMotClePublic=7;
    "</FONT>",
    //int estMotCleThis=8;
    "</FONT>",
    //int estMotCleTypeDeDonnee=9;
    "</FONT>",
    //chaine pour terminer la differenciation d'une "classe Java connue"
    //int estClasseJavaConnue=10;
    "</FONT>",
    //int estVariablePrivee=11;
    "",
    //int estVariablePublique=12;
    "",
    //chaine pour terminer la differenciation des nombres
    //int estEntier=13;
    "</B>",
    //int estHexadecimal=14;
    "</FONT>",
    //int estLong=15;
    "</FONT>",
    //int estOctal=16;
    "</FONT>",
    //int estDouble=17;
    "</FONT>",
    //int estFloat=18;
    "</FONT>",
    //int estInconnu=19;
    //chaine pour terminer la differenciation "des mots inconnus"
    ""
  };

  //tableau des separateurs
  char[] separateurs={' ', '\r', '\n', '\t', ';', ',', '(', ')', '{', '}', '=', '<', '>', '-', '+', '*', '/', '%', '^', '!', '?', '|', '&', ':', '~', '[', ']', '\''};
  //tableau representant les chiffres
  char[] chiffres={'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'x', '.', 'l'};
  //tableau de caracteres speciaux a remplacer
  char[] special={'\"', '&', '<', '>'};
  //tableau de chaines de remplacement des caracteres speciaux
  String[] strSpecial={"&quot;", "&amp;", "&lt;", "&gt;"};

  //information sur applet
  public String getAppletInfo() {
    return (new String("VasJavaVersHTML v2.0, 10 fevrier 1999, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }//fin getAppletInfo

  //fonction appellee en mode ligne de commande
  public static void main(String[] args) {
    VasJavaVersHTML maClasse=new VasJavaVersHTML(false);
    boolean forcer=false;
    if(args.length==0) {
      System.out.println("usage : VasJavaVersHTML [-f] fichier1 fichier2 ..\n-f re-ecrit les fichiers existants.");
      System.exit(1);
    }

    for(int i=0; i<args.length; i++) {
      //verifier si l'argument -f a ete passe
      if(args[i].equals("-f")) {
        forcer=true;
        continue;
      }//fin if
      try {
          String contenuFichier;
          String fichierNouveau=new String(args[i]+".html");
          RandomAccessFile fichier=new RandomAccessFile(args[i], "r");
          //mettre tout le fichier source dans la memoire
          {
            byte[] contenuF=new byte[(int)fichier.length()];
            fichier.readFully(contenuF);
            fichier.close();
            contenuFichier=new String(contenuF, 0);
          }//fin mettre
          //le fichier existe deja ?
          {
            File fichNouveau=new File(fichierNouveau);
            if(fichNouveau.exists()) {
              if(forcer) {
                fichNouveau.delete();
              }//fin if
              else {
                System.out.println("File "+fichierNouveau+" already exists.\nYou can use -f option to override it.");
                System.exit(-1);
              }//fin else
            }//fin if
          }//fin existe
          //ecriture du nouveau fichier HTML
          fichier=new RandomAccessFile(fichierNouveau, "rw");
          fichier.writeBytes(maClasse.transforme(contenuFichier));
          fichier.close();
      }//fin try
      catch(Exception e) {
        System.out.println("File problem");
        e.printStackTrace(System.out);
        System.exit(-1);
      }//fin catch
    }//fin for
  }//fin main

  //constructeur pour le mode ligne de commande
  public VasJavaVersHTML(boolean estApplet) {
    this.estApplet=estApplet;
  }//fin constructeur pour le mode ligne de commande

  //constructeur pour le mode applet
  public VasJavaVersHTML() {
    setLayout(null);
    setFont(new Font("Courier", Font.PLAIN, 12));
    setBackground(Color.lightGray);
    lEtat=new Label("Coller dans la TextArea le code Java et faites Go !");
    lEtat.reshape(10, 10, 360, 25);
    add(lEtat);

    bProceder=new Button("Go !");
    bProceder.reshape(385, 10, 70, 30);
    add(bProceder);

    taContenu=new TextArea();
    taContenu.reshape(20, 45, 435, 210);
    add(taContenu);
    taContenu.appendText("/* (C), vasile@wook.com */"
                         +sepLigne+"import java.awt.*;"
                         +sepLigne+sepLigne+"public class VasTest {"
                         +sepLigne+"  int hex=0x32;//commentaire C++"
                         +sepLigne+"  char c='\\\\';//un caractere"
                         +sepLigne+"  int entier=32;//ca marche :-)"
                         +sepLigne+"  int OCTAL=077;"
                         +sepLigne+"  float reel=.13f;"
                         +sepLigne+"  String chaine=\"Chaine\";"
                         +sepLigne+"}//fin VasTest");
    resize(470, 340);
  }//fin constructeur pour le mode applet

  //fonction appelee par le browser apres le constructeur
  public void init() {
    compo=new Component[2];
    compo[0]=taContenu;
    compo[1]=bProceder;
    compo[0].requestFocus();
    if(compo[0] instanceof TextComponent) ((TextComponent)compo[0]).selectAll();
  }//fin init

  //fonction principale pour la transformation du code Java en code HTML colore
  String transforme(String aTransformer){
    //pour voir dans combien de temps ca ete execute
    Date dDebut=new Date();

    //nettoyage des Hashtables et des Vectors
    //s'il y a deja quelque chose
    if(tousLesTokens.size()>0) {
      variablesPrivees=new Hashtable();
      variablesPubliques=new Hashtable();
      tousLesTokens=new Vector();
      typeDuToken=new Vector();
    }//fin if

    //ou commence le mot en cours
    int iDebMot=0;
    //le type du mot en cours
    int typeDeCeMot=estMot;
    //true si un mot est fini, false sinon
    boolean bFinMot=false;

    //on a un espace au debut
    if(estSeparateur(aTransformer.charAt(0))) {
      typeDeCeMot=estEspace;
      bFinMot=true;
    }//fin if

    //la longueur de la chaine a transformer
    int longueurChaine=aTransformer.length();

    //scannage de chaque caractere et son transformation dans une Vector de String
    for(int i=0; i<longueurChaine; i++) {
      if(estApplet && i%100==0) lEtat.setText("Analyse du caractere "+i+"/"+longueurChaine);
      //caractere courant
      char cCour=aTransformer.charAt(i);
      switch(cCour) {
        //pour marquer les chaines de caracteres
      case '\"' : {
        //on l'enregistre dans tousLesTokens
        tousLesTokens.addElement(aTransformer.substring(iDebMot, i));
        typeDuToken.addElement(new Integer(typeDeCeMot));
        int ancienI=i;
        i=obtientFinDuType(aTransformer, i+1, "\"");
        //on l'enregistre dans tousLesTokens
        tousLesTokens.addElement(aTransformer.substring(ancienI, i));
        typeDuToken.addElement(new Integer(estChaine));
        iDebMot=i;
        break;
      }//fin case "
        //on marque les caracteres
      case '\'' : {
        //on l'enregistre dans tousLesTokens
        tousLesTokens.addElement(aTransformer.substring(iDebMot, i));
        typeDuToken.addElement(new Integer(typeDeCeMot));
        int ancienI=i;
        i=obtientFinDuType(aTransformer, i+1, "'");
        //on l'enregistre dans tousLesTokens
        tousLesTokens.addElement(aTransformer.substring(ancienI, i));
        typeDuToken.addElement(new Integer(estCaractere));
        iDebMot=i;
        break;
      }//fin case '
        //on marque les commentaires
      case '*' : {
        if(i!=0 && aTransformer.charAt(i-1)=='/') {
          //on l'enregistre dans tousLesTokens
          tousLesTokens.addElement(aTransformer.substring(iDebMot, i-1));
          typeDuToken.addElement(new Integer(typeDeCeMot));
          int ancienI=i-1;
          i=obtientFinDuType(aTransformer, i, "*/");
          //on l'enregistre dans tousLesTokens
          tousLesTokens.addElement(aTransformer.substring(ancienI, i));
          typeDuToken.addElement(new Integer(estCommentaire1));
          iDebMot=i;
          break;
        }//fin if
      }//fin *
      case '/' : {
        if(i!=0 && aTransformer.charAt(i-1)=='/') {
          //on l'enregistre dans tousLesTokens
          tousLesTokens.addElement(aTransformer.substring(iDebMot, i-1));
          typeDuToken.addElement(new Integer(typeDeCeMot));
          int ancienI=i-1;
          i=obtientFinDuType(aTransformer, i, "\n");
          //on l'enregistre dans tousLesTokens
          tousLesTokens.addElement(aTransformer.substring(ancienI, i));
          typeDuToken.addElement(new Integer(estCommentaire2));
          iDebMot=i;
          break;
        }//fin if
      }//fin /
      default : {
        boolean sep=estSeparateur(cCour);
        if(bFinMot!=sep) {
          //on l'enregistre dans tousLesTokens
          tousLesTokens.addElement(aTransformer.substring(iDebMot, i));
          typeDuToken.addElement(new Integer(typeDeCeMot));
          //c'est le debut d'un nouveau mot
          iDebMot=i;
          //ca s'inverse
          bFinMot=!bFinMot;
        }//fin if
        if(sep) typeDeCeMot=estEspace;
        else typeDeCeMot=estMot;
        break;
      }//fin default
      }//fin switch i
    }//fin for

    //on ajoute le dernier element
    tousLesTokens.addElement(aTransformer.substring(iDebMot));
    typeDuToken.addElement(new Integer(typeDeCeMot));

    //on analyse tous les Tokens
    for(int i=0; i<tousLesTokens.size(); i++) {
      if(((Integer)typeDuToken.elementAt(i)).intValue()==estMot) typeDuToken.setElementAt(new Integer(analyseToken(i)), i);
    }//fin for

    StringBuffer resultat=new StringBuffer("<HTML>"+sepLigne+"<HEAD>"+sepLigne+"<TITLE>R&eacute;sultat de VasJavaVersHTML</TITLE>"+sepLigne+"<META NAME=\"GENERATOR\" CONTENT=\"VasJavaVersHTML\">"+sepLigne+"</HEAD>"+sepLigne+"<BODY BGCOLOR=\"#B4B88C\" TEXT=\"#000000\">"+sepLigne+"<PRE>"+strFont[estCommentaire1]+"/*"+sepLigne+"  Ce fichier a &eacute;t&eacute; &quot;HTMLis&eacute;&quot; par VasJavaVersHTML."+sepLigne+"  Pour plus d'informations visitez la page de <A HREF=\"http://www.chez.com/vasile/java2/VasJavaVersHTML.html\">VasJavaVersHTML</A>"+sepLigne+"  (C) 1997, 1998, 1999, 2000 Vasile Calmatui"+sepLigne+"*/"+strEndFont[estCommentaire1]+sepLigne);

    int nbTokens=tousLesTokens.size();
    for(int i=0; i<nbTokens; i++) {
      int type=((Integer)typeDuToken.elementAt(i)).intValue();
      resultat.append(strFont[type]);
      resultat.append(escapeHTML((String)tousLesTokens.elementAt(i)));
      resultat.append(strEndFont[type]);
    }//fin for

    resultat.append(sepLigne+"</PRE>"+sepLigne+"&copy; 1997, 1998, 1999, 2000 fait avec <A HREF=\"http://www.chez.com/vasile/java2/VasJavaVersHTML.html\">VasJavaVersHTML</A><BR><BR></BODY>"+sepLigne+"</HTML>");

    if(estApplet) lEtat.setText("Execute en "+((new Date()).getTime()-dDebut.getTime()) + " millisec. "+resultat.length()+" caracteres.");

    return resultat.toString();
  }//fin transforme

  //on analyse le token
  //on regarde si c'est pas un mot cle
  //retourne le type du token
  int analyseToken(int pos) {
    String motTrouve=(String)tousLesTokens.elementAt(pos);
    //non valide
    if(motTrouve.length()<1) return estEspace;

    //on regarde si c'est pas un nombre
    //si ca commence avec une lettre, alors c'est pas un nombre
    //meme pas avec a, b, c, d, e, f, x, l
    //un mot reserver ne peut pas commencer avec un chiffre
    //mais peut commencer avec "."
    {
      char c=motTrouve.charAt(0);
      if((c>='0' && c<='9') || (c=='.' && motTrouve.length()>1 && motTrouve.charAt(1)>='0' && motTrouve.charAt(1)<='9')) return metTypeChiffre(motTrouve);
    }//fin on regarde si c'est pas un nombre

    //on traite le cas special de "quelquechose.autrechose"
    //decoupage du mot
    {
      int emplacementPoint=motTrouve.indexOf('.');
      //si c'est quelque chose du genre maVariable.quelquechose
      if(emplacementPoint>0) {
        tousLesTokens.insertElementAt(motTrouve.substring(emplacementPoint+1), pos+1);
        typeDuToken.insertElementAt(new Integer(estMot), pos+1);
        tousLesTokens.insertElementAt(".", pos+1);
        typeDuToken.insertElementAt(new Integer(estEspace), pos+1);
        motTrouve=new String(motTrouve.substring(0, emplacementPoint));
        tousLesTokens.setElementAt(motTrouve, pos);
      }//fin if
    }//fin decoupage du mot

    //on regarde si c'est un mot reserve
    for(int i=0; i<motsCle.length; i++) {
      if(motTrouve.equals(motsCle[i])) {
        if(motsCle[i].equals("public")) return estMotClePublic;
        if(motsCle[i].equals("this")) return estMotCleThis;
        //si ce mot cle est un type de donnee, on le marque
        for(int k=0; k<types.length; k++) {
          if(motsCle[i].equals(types[k])) return estMotCleTypeDeDonnee;
        }//fin for
        return estMotCle;
      }//fin if
    }//fin for
    //on regarde si c'est une "classe Java connue"
    for(int i=0; i<classes.length; i++) {
      if(motTrouve.equals(classes[i])) return estClasseJavaConnue;
    }//fin for

    //deja dans variablesPrivees ?
    if(variablesPrivees.containsKey(motTrouve)) {
      //si c'est du genre System.out.println
      //et quand out c'est une variable deja definie
      if((pos-2)>0 && ((String)tousLesTokens.elementAt(pos-1)).equals(".") && !(((String)tousLesTokens.elementAt(pos-2)).equals("this"))) return estInconnu;
      tousLesTokens.setElementAt((String)variablesPrivees.get(motTrouve), pos);
      return estVariablePrivee;
    }//fin if

    //deja dans variablesPublic ?
    if(variablesPubliques.containsKey(motTrouve)) return estVariablePublique;

    //est-ce le nom d'une fonction ?
    //oui, s'il a une parenthese apres le nom
    boolean isFunction=espaceAParenthese(pos);

    //ce mot est une varialbe publique ?
    if(estPublic(pos) && !isFunction) {
      variablesPubliques.put(motTrouve, motTrouve);
      return estVariablePublique;
    }//fin if


    //si c'est pas un mot reserve, pas un nombre, pas une classe Java,
    //alors ca peut etre une variable locale si n'a pas l'air d'une fonction
    //et n'a pas ete defini avant
    if(previousWordWasDataType(pos) && !isFunction) {
      variablesPrivees.put(motTrouve, motTrouve);
      return estVariablePrivee;
    }//fin if

    //unconnu
    return estInconnu;
  }//fin analyseToken

  //a ete le mot precedent un type de donnee ?
  boolean previousWordWasDataType(int pos) {
    //on scanne tous les tokens avant cette position
    while(--pos>0) {
      int type=((Integer)typeDuToken.elementAt(pos)).intValue();
      //on continue d'analyser, ce sont juste des commentaires
      if(type==estCommentaire1 || type==estCommentaire2) continue;
      else {
        if(type==estClasseJavaConnue || type==estMotCleTypeDeDonnee || type==estVariablePrivee) return true;
        if(type==estEspace) {
          //il peut y avoir juste des blancs, des virgules et []
          String monMot=(String)tousLesTokens.elementAt(pos);
          int longueurChaine=monMot.length();
          for(int i=0; i<longueurChaine; i++) {
            char c=monMot.charAt(i);
            if(!(c==' ' || c==',' || c=='\t' || c=='[' || c==']')) return false;
          }//fin for
          continue;
        }//fin if
        return false;
      }//fin else
    }//fin while
    return false;
  }//fin previousWordWasDataType

  //est-ce que l'espace precedent a eu une parenthese, cad est une fonction ?
  boolean espaceAParenthese(int pos) {
    //on scanne tous les tokens avant cette position
    while(++pos<typeDuToken.size()) {
      int type=((Integer)typeDuToken.elementAt(pos)).intValue();
      //on continue d'analyser, ce sont juste des commentaires
      if(type==estCommentaire1 || type==estCommentaire2) continue;
      else {
        if(type==estEspace) {
          //il peut y avoir juste des blancs
          String monMot=(String)tousLesTokens.elementAt(pos);
          int longueurChaine=monMot.length();
          for(int i=0; i<longueurChaine; i++) {
            char c=monMot.charAt(i);
            if(c==' ' || c=='\t') continue;
            if(c=='(') return true;
            return false;
          }//fin for
        }//fin if
        return false;
      }//fin else
    }//fin while
    return false;
  }//fin espaceAParenthese

  //est ce mot public ou non
  boolean estPublic(int pos) {
    //on scanne tous les tokens avant cette position
    while(--pos>0) {
      int type=((Integer)typeDuToken.elementAt(pos)).intValue();
      //on continue d'analyser, ce sont juste des commentaires
      if(type==estCommentaire1 || type==estCommentaire2) continue;
      else {
        if(type==estVariablePublique || type==estMotClePublic) return true;
        if(type==estMotCle || type==estClasseJavaConnue || type==estMotCleTypeDeDonnee) continue;
        if(type==estEspace) {
          //il peut y avoir juste des blancs, des virgules et []
          String monMot=(String)tousLesTokens.elementAt(pos);
          int longueurChaine=monMot.length();
          for(int i=0; i<longueurChaine; i++) {
            char c=monMot.charAt(i);
            if(!(c==' ' || c==',' || c=='\t' || c=='[' || c==']')) return false;
          }//fin for
          continue;
        }//fin if
        return false;
      }//fin else
    }//fin while
    return false;
  }//fin estPublic

  //est ce caractere "escaped" ?
  //par exemple "\\n" n'est pas "escaped"
  boolean isNotEscaped(String maChaine, int charPosition) {
    int i=1;
    for(; (charPosition-i)>=0; i++) {
      if(maChaine.charAt(charPosition-i)!='\\') break;
    }//fin for
    if(i%2==0) return false;
    return true;
  }//isNotEscaped

  //est-ce que ce caractere est un separateur ?
  boolean estSeparateur(char car) {
    for(int i=0; i<separateurs.length; i++) {
      if(car==separateurs[i]) return true;
    }//fin for
    return false;
  }//fin estSeparateur

  //dans la chaine maChaine cherche pour la premier occurence
  //de quoiArrete qui ne soit pas "escaped"
  int obtientFinDuType(String maChaine, int ou, String quoiArrete) {
    int longueurChaine=maChaine.length();
    int longueurQuoi=quoiArrete.length();
    //on cherche la chaine quoiArete
    while(ou<(longueurChaine-longueurQuoi)) {
      int j=0;
      while(j<longueurQuoi && maChaine.charAt(ou+j)==quoiArrete.charAt(j)) {j++;}
      if(j==longueurQuoi && isNotEscaped(maChaine, ou)) {
        ou+=longueurQuoi;
        break;
      }//fin if
      ou++;
    }//fin while
     //si on arrive a la fin du fichier
    if(ou==longueurChaine-longueurQuoi) ou+=longueurQuoi;
    return ou;
  }//fin obtientFinDuType

  //escapes special HTML characters like <, & ...
  //returns the escaped string
  StringBuffer escapeHTML(String toEscape) {
    StringBuffer out=new StringBuffer(toEscape);
    for(int j=0; j<out.length(); j++) {
      for(int i=0; i<special.length; i++) {
        if(out.charAt(j)==special[i]) {
          out.setCharAt(j, strSpecial[i].charAt(0));
          if(strSpecial[i].length()>1) {
            out.insert(j+1, strSpecial[i].substring(1));
            j+=strSpecial[i].length()-1;
          }//fin if
        }//fin if
      }//fin for
    }//fin for
    return out;
  }//fin escapeHTML

  //si c'est un nombre, on met le bon type
  int metTypeChiffre(String toAnalyze) {
    //que des chiffres : entier
    //debut 0 : octal, 0-7
    //debut 0x ou 0X : hexa => 0-9 + droit abcdefABCDEF
    //entier avec l ou L final : entier long
    //entier.entier : reel (double par defaut)
    //reel avec e ou E : reel (double par defaut)
    //reel avec d ou D final : double
    //reel avec f ou F final : float

    //on obtient un tableau de caracteres
    char[] chiffre=toAnalyze.toCharArray();

    //par defaut, c'est un entier
    int type=estEntier;

    int j=0;
    int figLength=chiffres.length;
    int wordLength=chiffre.length;
    //on regarde si chaque caractere est un numero
    do {
      chiffre[j]=Character.toLowerCase(chiffre[j]);
      int i=0;
      do {
        if(chiffre[j]==chiffres[i]) {
          if(chiffre[j]=='.' || chiffre[j]=='e') {
            //alors c'est un double
            type=estDouble;
          }//fin if
          break;
        }//fin if
      } while(++i<figLength);
      //c'est pas un nombre, on sort
      if(i==figLength) return estMot;
    } while(++j<wordLength);

    //alors c'est un nombre (contenant seulement des caracteres a partir du tableau de caracteres)
    if(chiffre[0]=='0') {
      if(chiffre.length>1) {
        //hexa
        if(chiffre[1]=='x') type=estHexadecimal;
        //octal
        else type=estOctal;
      }//fin if
    }//fin if
    switch(chiffre[chiffre.length-1]) {
      //double
    case 'd' : type=estDouble;
      break;
      //float
    case 'f' : type=estFloat;
      break;
      //long
    case 'l' : type=estLong;
      break;
    }//fin switch
    return type;
  }//fin metTypeChiffre

  public boolean handleEvent(Event e) {
    //pour passer d'une case a l'autre avec tabulation
    if(e.id==Event.KEY_PRESS && e.key == '\t') {
      for(int i=0; i<compo.length; i++) {
        if(e.target==compo[i]) {
          //en IE4, le texte reste selectionne
          //c'est pas joly, donc on de-selectionne avant de partir
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).select(0, 0);
          //s'il y a un composant "disabled", on passe plus loin
          do {
            i=(i+(e.shiftDown() ? compo.length-1 : 1))%compo.length;
          } while (!compo[i].isEnabled());
          compo[i].requestFocus();
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).selectAll();
          return true;
        }//fin if
      }//fin for
      return false;
    }//fin '\t'

    if(e.target==bProceder && (e.arg==bProceder.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      //on transforme et on met le texte
      taContenu.setText(transforme(taContenu.getText()));
      return true;
    }//fin if
    return false;//les autres evenements ne seront pas traites
  }//fin handleEvent
}//fin classe VasJavaVersHTML
